-- 
-- easyDestro and addon based on Falie work, modified by Kyraka
--

easyDestro = {}


easyDestro.versionNumber = 2.0
easyDestro.currentTarget = ""
easyDestro.currentSpell = ""
easyDestro.lastTarget = ""
easyDestro.IMTarget = "" -- used for Immolate tracking as there's no succed on cast
easyDestro.CorrTarget = "" -- used for Corruption tracking as there's no succed on cast,
easyDestro.npcList = {} -- {guid, name}
easyDestro.immoList = {} -- {guid, GetTime}
easyDestro.corrList = {} -- {guid, GetTime}
easyDestro.cboltTime = 0
easyDestro.confTime = 0
easyDestro.timeSinceLastUpdate = 0
easyDestro.cboltCooldown = 12 --TODO check for chaos bolt glyph for reduced CD
easyDestro.shouldCheckStuff = false; --TO DO dheck for different warlock stuff



--for internationalization, thanks to ckaotic from wowinterface.com

easyDestro.spellname = {
	["Immolate"] = GetSpellInfo(348),
	["Incinerate"] = GetSpellInfo(29722),
	["Chaos Bolt"] = GetSpellInfo(50796),
	["Conflagrate"] = GetSpellInfo(17962),
	["Curse of Agony"] = GetSpellInfo(980),
	["Curse of the Elements"] = GetSpellInfo(1490),
	["Bane of Doom"] = GetSpellInfo(603),
	["Life Tap"] = GetSpellInfo(1454),
	["Soul Fire"] = GetSpellInfo(6353),
	["Corruption"] = GetSpellInfo(172),
  ["Shadow Bold"] = GetSpellInfo(686)
}

-- those are used to include a curse in rotation. default there is no curse in rotation, but as soon as a curse is casted on a target will be maintained on that target
easyDestro.coaTarget = ""
easyDestro.coeTarget = ""
easyDestro.codTarget = ""
--easyDestro.codCooldown = 60
easyDestro.codTime = 0
easyDestro.coaTime = 0
easyDestro.coeTime = 0
easyDestro.codList = {} -- {guid, GetTime}
easyDestro.coaList = {} -- {guid, GetTime}
easyDestro.coeList = {} -- {guid, GetTime}

easyDestro.targetPrio = {} --keep prio per target
		  

easyDestro.playerName = UnitName("player");
easyDestro.spellHaste = GetCombatRatingBonus(20)

easyDestro.textureList = {
  ["Imm"] = GetSpellTexture(easyDestro.spellname["Immolate"]),
  ["Inc"] = GetSpellTexture(easyDestro.spellname["Incinerate"]),
  ["CB"] = GetSpellTexture(easyDestro.spellname["Chaos Bolt"]),
  ["CFG"] = GetSpellTexture(easyDestro.spellname["Conflagrate"]),
  ["CoA"] = GetSpellTexture(easyDestro.spellname["Curse of Agony"]),
  ["CoE"] = GetSpellTexture(easyDestro.spellname["Curse of the Elements"]),
  ["BoD"] = GetSpellTexture(easyDestro.spellname["Bane of Doom"]),
  ["SF"] = GetSpellTexture(easyDestro.spellname["Soul Fire"]),
  ["Corr"] = GetSpellTexture(easyDestro.spellname["Corruption"]),
  ["SB"] = GetSpellTexture(easyDestro.spellname["Shadow Bold"]),
  ["last"] = nil,
  ["current"] = nil,
  ["next"] = nil,
  ["highlight"] = nil,
  }

easyDestro.spellList = {
  ["last"] = "",
  ["current"] = "",
  ["next"] = "",
  ["third"] = "",
}

-- event frame with all arguments
easyDestro.eventFrame = CreateFrame("Frame")
easyDestro.eventFrame:SetScript("OnEvent", function(this, event, ...)
  --DEFAULT_CHAT_FRAME:AddMessage("EVENT: "..event);
  if event == "PLAYER_LOGIN" or event == "ADDON_LOADED" or event == "COMBAT_LOG_EVENT_UNFILTERED" or event == "COMBAT_RATING_UPDATE" or event == "PLAYER_TARGET_CHANGED" or event == "PLAYER_REGEN_ENABLED" then
  	easyDestro.events[event](...)
  end
end)

easyDestro.eventFrame:RegisterEvent("ADDON_LOADED")
easyDestro.eventFrame:RegisterEvent("PLAYER_LOGIN")


-- manipulate envents here
easyDestro.events = {}

function easyDestro.setPRIO() 
  easyDestro.targetPrio = {} --reset all on change, better change only when not in combat
  	easyDestro.NoCPrio = {
  		[1] = "Imm",
  		[2] = "CFG",
			[3] = "BoD",
			[4] = "Corr",
  		[5] = "CB"
  			  }
  	easyDestro.CoAPrio = {
  		[1] = "CoA",
  		[2] = "Imm",
  		[3] = "CFG",
			[4] = "BoD",
			[5] = "Corr",
  		[6] = "CB"
  			  }
  	easyDestro.CoEPrio = {
  		[1] = "CoE",
  		[2] = "Imm",
  		[3] = "CFG",
			[4] = "BoD",
			[5] = "Corr",
  		[6] = "CB"
  			  }
end


function easyDestro.events.PLAYER_LOGIN()

  easyDestro.playerName = UnitName("player");
  easyDestro.spellHaste = GetCombatRatingBonus(20)
  easyDestro.setPRIO()
 
  easyDestro.textureList["Imm"] = GetSpellTexture(easyDestro.spellname["Immolate"])
  easyDestro.textureList["Inc"] = GetSpellTexture(easyDestro.spellname["Incinerate"])
  easyDestro.textureList["CB"] = GetSpellTexture(easyDestro.spellname["Chaos Bolt"])
  easyDestro.textureList["CFG"] = GetSpellTexture(easyDestro.spellname["Conflagrate"])
  easyDestro.textureList["CoA"] = GetSpellTexture(easyDestro.spellname["Curse of Agony"])
  easyDestro.textureList["CoE"] = GetSpellTexture(easyDestro.spellname["Curse of the Elements"])
  easyDestro.textureList["BoD"] = GetSpellTexture(easyDestro.spellname["Bane of Doom"])
  easyDestro.textureList["SF"] = GetSpellTexture(easyDestro.spellname["Soul Fire"])
  easyDestro.textureList["Corr"] = GetSpellTexture(easyDestro.spellname["Corruption"])
  
end

function easyDestro.events.ADDON_LOADED(addon)

  if addon ~= "easyDestro" then return end
  local _,playerClass = UnitClass("player")
  if playerClass ~= "WARLOCK" then return end
  
  -- Default saved variables
  if not easydestrodb then 
    easydestrodb = {} -- fresh start
  end
  
  easydestrodb.locked = false
  if not easydestrodb.scale then easydestrodb.scale = 1 end
  if not easydestrodb.x then easydestrodb.x = 100 end
  if not easydestrodb.y then easydestrodb.y = 100 end
  easydestrodb.pri = {}
  easydestrodb.pri[1] = "Imm"
  easydestrodb.pri[2] = "CFG"
  easydestrodb.pri[3] = "BoD"
  easydestrodb.pri[4] = "Corr"
  easydestrodb.pri[5] = "CB"
  easydestrodb.pri[6] = "Inc"
  
  -- interface
  easyDestro:CreateGUI()
  easyDestro.displayFrame:SetScale(easydestrodb.scale)
  
  easyDestro.gcdbar:Hide()  
  
  -- Create Options Frame
  easyDestro:CreateOptionFrame()
 
  if easydestrodb.locked then
    easyDestro.displayFrame:SetScript("OnMouseDown", nil)
    easyDestro.displayFrame:SetScript("OnMouseUp", nil)
    easyDestro.displayFrame:SetScript("OnDragStop", nil)
    easyDestro.displayFrame:SetBackdropColor(0, 0, 0, 0)
    easyDestro.displayFrame:EnableMouse(false)
  else
    easyDestro.displayFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
    easyDestro.displayFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
    easyDestro.displayFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
    easyDestro.displayFrame:SetBackdropColor(0, 0, 0, .4)
    easyDestro.displayFrame:EnableMouse(true)
  end
  
  -- Register for Slash Commands
  SlashCmdList["easyDestro"] = easyDestro.Options
  SLASH_easyDestro1 = "/easydestro"
  SLASH_easyDestro2 = "/es"
  
  -- Register for Function Events
  easyDestro.eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  easyDestro.eventFrame:RegisterEvent("COMBAT_RATING_UPDATE") -- Monitor the all-mighty haste
  easyDestro.eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
  easyDestro.eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED") -- Left combat, clean up all enemy GUIDs
  easyDestro.eventFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
  easyDestro.eventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")

  
end

function easyDestro.events.COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
  
  if srcName == easyDestro.playerName then
    --DEFAULT_CHAT_FRAME:AddMessage("SPELL_CAST_START: "..dstGUID);
    local ctime = GetTime()
    easyDestro.npcList[dstGUID] = dstName
    if event == "SPELL_CAST_START" then
      local _, spellName = ...
      --DEFAULT_CHAT_FRAME:AddMessage("SPELL_CAST_START: "..spellName);
      if spellName == easyDestro.spellname["Chaos Bolt"] then
        easyDestro.currentSpell = "CB"
        easyDestro.cboltTime = easyDestro.cboltTime + 1 --hack for delayed SPELL_DAMAGE event
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(0) end
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Immolate"] then
        easyDestro.currentSpell = "Imm"
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(0) end
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Incinerate"] then
        easyDestro.currentSpell = "Inc"
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(0) end
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Soul Fire"] then
        easyDestro.currentSpell = "SF"
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(0) end
        easyDestro:PushDisplay()
      end
      
    elseif event == "SPELL_DAMAGE" then
      local _,spellName = ...
      if spellName == easyDestro.spellname["Immolate"] then
        easyDestro.immoList[dstGUID] = ctime -- set the time for current time
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end    
      elseif spellName == easyDestro.spellname["Chaos Bolt"] then
        easyDestro.cboltTime = ctime
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end
      end
      
    elseif event == "SPELL_CAST_SUCCESS" then
      local _, spellName = ...  
      --DEFAULT_CHAT_FRAME:AddMessage("SPELL_CAST_SUCCESS: "..spellName);
      if spellName == easyDestro.spellname["Conflagrate"] then
        easyDestro.currentSpell = "CFG"
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(0) end
        easyDestro.confTime = ctime
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Curse of Agony"] then
        easyDestro.targetPrio[dstGUID] = easyDestro.CoAPrio
        easyDestro.coaList[dstGUID] = ctime -- set the time for current time
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Bane of Doom"] then
        easyDestro.currentSpell = "BoD"
        easyDestro.codList[dstGUID] = ctime -- set the time for current time
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Curse of the Elements"] then
        easyDestro.targetPrio[dstGUID] = easyDestro.CoEPrio
        easyDestro.coeList[dstGUID] = ctime -- set the time for current time
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end
        easyDestro:PushDisplay()
      elseif spellName == easyDestro.spellname["Corruption"] then
        easyDestro.currentSpell = "Corr"
        easyDestro.corrList[dstGUID] = ctime -- set the time for current time
        if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end
        easyDestro:PushDisplay()
      end
         
    end
    
  end
  
end

function easyDestro.events.COMBAT_RATING_UPDATE(unit)
  if unit == "player" then
    easyDestro.spellHaste = GetCombatRatingBonus(20) -- update spell haste
  end
end

function easyDestro.events.PLAYER_TARGET_CHANGED(...) 
  -- target changed, set last target, update current target, will be nil if no target
  if (easyDestro.shouldCheckStuff) then
    easyDestro:CheckStuff()
    easyDestro.shouldCheckStuff = false
  end
  
  easyDestro.lastTarget = easyDestro.currentTarget
  easyDestro.currentTarget = UnitGUID("target")
  
  if easyDestro.currentTarget and not easyDestro.targetPrio[easyDestro.currentTarget] then easyDestro.targetPrio[easyDestro.currentTarget] =  easyDestro.NoCPrio end
  
  if UnitName("target") == nil or UnitIsFriend("player","target") ~= nil or UnitHealth("target") == 0 then
    easyDestro.displayFrame_last:Hide()
    easyDestro.displayFrame_current:Hide()
    easyDestro.displayFrame_next:Hide()
    easyDestro.displayFrame_currentHighlight:Hide()
  else
    easyDestro.displayFrame_currentHighlight:Show()
    easyDestro.displayFrame_last:Show()
    easyDestro.displayFrame_current:Show()
    easyDestro.displayFrame_next:Show()
  end
  easyDestro:DecideSpells()
end

function easyDestro.events.PLAYER_REGEN_ENABLED(...)
  -- We have left combat, clean up GUIDs
  -- DEFAULT_CHAT_FRAME:AddMessage("REGEN!!!! ");
  easyDestro.npcList = {} -- {guid, name}
  easyDestro.immoList = {} -- {guid, GetTime}
  easyDestro.corrList = {}
  easyDestro.targetPrio = {} -- reset all targets prios
  easyDestro.codList = {}
  easyDestro.coaList = {}
  easyDestro.coeList = {}
  
  if UnitExists("target") and not UnitIsFriend("player", "target") and UnitHealth("target") > 0 then
    easyDestro.targetPrio[UnitGUID("target")] =  easyDestro.NoCPrio
  end
end

-- End Event Handlers

function easyDestro:CreateGUI()

  local displayFrame = CreateFrame("Frame","easyDestroDisplayFrame",UIParent)
  displayFrame:SetFrameStrata("BACKGROUND")
  displayFrame:SetWidth(250)
  displayFrame:SetHeight(90)
  displayFrame:SetBackdrop({
          bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32,
  			})
  displayFrame:SetBackdropColor(0, 0, 0, .4)
  displayFrame:EnableMouse(true)
  displayFrame:SetMovable(true)

  displayFrame:SetClampedToScreen(true)
  displayFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
  displayFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
  displayFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

  displayFrame:SetPoint("CENTER",-200,-200)
  
  local displayFrame_last = CreateFrame("Frame","$parent_last", easyDestroDisplayFrame)
  local displayFrame_currentHighlight = CreateFrame("Frame","$parent_currentHighlight", easyDestroDisplayFrame)
  local displayFrame_current = CreateFrame("Frame","$parent_current", easyDestroDisplayFrame_currentHighlight)
  local displayFrame_next = CreateFrame("Frame","$parent_next", easyDestroDisplayFrame)
  
  displayFrame_last:SetWidth(70)
  displayFrame_current:SetWidth(70)
  displayFrame_currentHighlight:SetWidth(80)
  displayFrame_next:SetWidth(70)
  
  displayFrame_last:SetHeight(70)
  displayFrame_current:SetHeight(70)
  displayFrame_currentHighlight:SetHeight(80)
  displayFrame_next:SetHeight(70)
  
  
  
  
  displayFrame_last:SetPoint("TOPLEFT", 10, -10)
  displayFrame_currentHighlight:SetPoint("TOPLEFT", 85, -5)
  displayFrame_current:SetPoint("TOPLEFT", 5, -5)
  displayFrame_next:SetPoint("TOPLEFT", 170, -10)
  
    
  local t = displayFrame_last:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:SetAllPoints(displayFrame_last)
  t:SetAlpha(.2)
  displayFrame_last.texture = t
  easyDestro.textureList["last"] = t
  
  t = displayFrame_current:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:ClearAllPoints()
  t:SetAllPoints(displayFrame_current)
  displayFrame_current.texture = t
  easyDestro.textureList["current"] = t
  
  t = displayFrame_next:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:SetAllPoints(displayFrame_next)
  t:SetAlpha(.5)
  displayFrame_next.texture = t
  easyDestro.textureList["next"] = t
  
  t = displayFrame_currentHighlight:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(.1,.5,.1)
  t:SetAllPoints(displayFrame_currentHighlight)
  t:SetAlpha(0)
  displayFrame_currentHighlight.texture = t
  easyDestro.textureList["highlight"] = t
    
  displayFrame:SetScript("OnUpdate", function(this, elapsed)
    easyDestro:OnUpdate(elapsed)
  end)
  
  local cooldownFrame = CreateFrame("Cooldown","$parent_cooldown", easyDestroDisplayFrame_current)
  cooldownFrame:SetHeight(70)
  cooldownFrame:SetWidth(70)
  cooldownFrame:ClearAllPoints()
  cooldownFrame:SetPoint("CENTER", displayFrame_current, "CENTER", 0, 0)
  
  easyDestro.displayFrame = displayFrame
  easyDestro.displayFrame_last = displayFrame_last
  easyDestro.displayFrame_current = displayFrame_current
  easyDestro.displayFrame_next = displayFrame_next
  easyDestro.displayFrame_currentHighlight = displayFrame_currentHighlight
  easyDestro.cooldownFrame = cooldownFrame
  

  local gcdbar = CreateFrame('Frame', 'easyDestroGCDBar', UIParent)
  gcdbar:SetFrameStrata('HIGH')
  gcdbar:SetScript('OnShow', function() easyDestro.OnShowGCD() end)
  gcdbar:SetScript('OnHide', function() easyDestro.OnHideGCD() end)
  local gcdspark = gcdbar:CreateTexture(nil, 'DIALOG')
  easyDestro.gcdstart = 0
  easyDestro.gcdduration = 0
  gcdbar:ClearAllPoints()
  gcdbar:SetHeight(10)
  gcdbar:SetWidth(250)
  gcdbar:SetPoint("BOTTOM", easyDestroDisplayFrame, "TOP", 0, 0)
  gcdspark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
  gcdspark:SetVertexColor(1, 1, 1)
  gcdspark:SetBlendMode('ADD')
  gcdspark:SetWidth(25)
  gcdspark:SetHeight(10)
  easyDestro.gcdbar = gcdbar
  easyDestro.gcdspark = gcdspark
  
  local displayFrame_options = CreateFrame("Frame","$parent_options", easyDestroDisplayFrame)
  displayFrame_options:SetWidth(70)
  displayFrame_options:SetHeight(30)
  displayFrame_options:SetPoint("BOTTOMLEFT", 0, -0)
  
  easyDestro.displayFrame_options = displayFrame_options
    
  displayFrame:Show()
  
end


function easyDestro.OnHideGCD()
	easyDestro.gcdbar:SetScript('OnUpdate', nil)
end

function easyDestro.OnShowGCD()
	easyDestro.gcdbar:SetScript('OnUpdate', function() easyDestro.OnUpdateGCD() end)
end

function easyDestro.OnUpdateGCD()
	easyDestro.gcdspark:ClearAllPoints()
	local perc = (GetTime() - easyDestro.gcdstart) / easyDestro.gcdduration
	if perc > 1 then
	  if easyDestro.currentSpell == "CFG" or easyDestro.currentSpell == "Inc" then
	    if(easyDestro.textureList["highlight"]) then easyDestro.textureList["highlight"]:SetAlpha(1) end
	  end
		return easyDestro.gcdbar:Hide()
	else
		easyDestro.gcdspark:SetPoint('CENTER', easyDestro.gcdbar, 'LEFT', 250 * perc, 0)
	end	
end



function easyDestro:OnUpdate(elapsed)
  easyDestro.timeSinceLastUpdate = easyDestro.timeSinceLastUpdate + elapsed; 
  
  if (easyDestro.timeSinceLastUpdate > (1.5 - (1.5 * easyDestro.spellHaste * .01)) * 0.3) then
    easyDestro:DecideSpells()
  end

end



function easyDestro:PushDisplay()
  
  -- Move to the new spell to cast
  if easyDestro.currentSpell == easyDestro.spellList["current"] then
    easyDestro.textureList["last"]:SetTexture(easyDestro.textureList[easyDestro.spellList["current"]])
    easyDestro.textureList["current"]:SetTexture(easyDestro.textureList[easyDestro.spellList["next"]])
    easyDestro.textureList["next"]:SetTexture(easyDestro.textureList[easyDestro.spellList["third"]])
    
    easyDestro.spellList["last"] = easyDestro.spellList["current"]
    easyDestro.spellList["current"] = easyDestro.spellList["next"]
    easyDestro.spellList["next"] = easyDestro.spellList["third"]
    easyDestro.spellList["third"] = ""
  end
  easyDestro:DecideSpells()
end



function easyDestro:DecideSpells()

  easyDestro.timeSinceLastUpdate = 0;
  if  UnitName("target") == nil or UnitIsFriend("player","target") ~= nil or UnitHealth("target") == 0 then
    return -- ignore the dead and friendly
  end
  local firstSpell = ""
  local secondSpell = ""
  local thirdSpell = ""
  local guid = UnitGUID("target")
  local currentTime = GetTime()
  local GCD = 1.5 - (1.5 * easyDestro.spellHaste * .01)
  
  if guid == nil then
    easyDestro.textureList["last"]:SetTexture(nil)
    easyDestro.textureList["current"]:SetTexture(nil)
    easyDestro.textureList["next"]:SetTexture(nil)
    easyDestro.spellList["last"] = ""
    easyDestro.spellList["current"] = ""
    easyDestro.spellList["next"] = ""
    easyDestro.spellList["third"] = ""
    return
  end

    
    --DEFAULT_CHAT_FRAME:AddMessage("target: "..easyDestro.currentTarget.." guid: "..guid.." tabel : "..easyDestro.targetPrio[guid][1])
    
    --DEFAULT_CHAT_FRAME:AddMessage("TABELU: ".. table.concat(easyDestro.targetPrio, ", "))
    
    -- check for Soul Fire usage
    local hp = UnitHealth("target")
    local maxhp = UnitHealthMax("target")
    if(hp/maxhp*100 > 80) then
      local n,_,_,_,_,_,isf = UnitAura("player", "Improved Soul Fire")
      if(isf) then
        if(isf - currentTime < 2) then
          firstSpell = "SF"
        elseif(isf - currentTime < 4) then
          secondSpell = "SF"
        end
      else
        firstSpell = "SF"
      end
    end
    
    local empImp = UnitAura("player", "Empowered Imp")
    if empImp then
      firstSpell = "SF"
    end
    
    for pri in ipairs(easyDestro.targetPrio[guid]) do
      local spell = easyDestro.targetPrio[guid][pri]
      if easyDestro.currentSpell == spell then
        -- skip if we just cast the spell but it hasn't cleared yet
      else
        local timeUntilNext = 0
        -- set up our test subjects  
        if spell == "CoA" then
          timeUntilNext = 24 - (currentTime - easyDestro.coaList[guid])
        elseif spell == "BoD" and easyDestro.codList[guid] ~= nil then
          timeUntilNext = 60 - (currentTime - easyDestro.codList[guid]) 
        elseif spell == "CoE" then
          timeUntilNext = 300 - (currentTime - easyDestro.coeList[guid])  
        elseif spell == "Imm" and easyDestro.immoList[guid] ~= nil then
          timeUntilNext = 15 - GCD - (currentTime - easyDestro.immoList[guid])    -- dot clipping is not a problem anymore, so 14 instead of 15 to have Imm always up
        elseif spell == "Corr" and easyDestro.corrList[guid] ~= nil then
          timeUntilNext = 17 - GCD -(currentTime - easyDestro.corrList[guid])    -- dot clipping is not a problem anymore  
        elseif spell == "CFG" then
          timeUntilNext = 10 - (currentTime - easyDestro.confTime)        
        elseif spell == "CB" then
          timeUntilNext = easyDestro.cboltCooldown - (currentTime - easyDestro.cboltTime)
        end

--DEFAULT_CHAT_FRAME:AddMessage("time: "..timeUntilNext.." spell: "..spell.." PRIO: "..pri.." GCD: "..GCD.." CURRENT: "..currentTime)

        -- run our tests
        
        
        if timeUntilNext < GCD then
        --DEFAULT_CHAT_FRAME:AddMessage("SPELL: "..spell)
          if firstSpell == "" then
            firstSpell = spell
          elseif secondSpell == "" then
            secondSpell = spell
          elseif thirdSpell == "" then
            thirdSpell = spell
          end
        elseif timeUntilNext < GCD * 2 then
          if secondSpell == "" then
            secondSpell = spell
          elseif thirdSpell == "" then
            thirdSpell = spell
          end
        elseif timeUntilNext < GCD * 3 then
          if thirdSpell == "" then
            thirdSpell = spell
          end
        end 
        -- test ended
        
      end
    
    end  
    
    -- If still empty, fill in with Incinerate 
    if firstSpell == "" then
      firstSpell = "Inc"
    end
    if secondSpell == "" and firstSpell ~= "Inc" then
      secondSpell = "Inc"
    end
    if thirdSpell == "" and secondSpell ~= "Inc" then
      thirdSpell = "Inc"
    end
    
    --DEFAULT_CHAT_FRAME:AddMessage("fSPELL: "..firstSpell.."fSPELL1: "..easyDestro.spellList["current"] )
    if easyDestro.spellList["current"] == firstSpell then
      -- yay
    else
      easyDestro.spellList["current"] = firstSpell
      easyDestro.textureList["current"]:SetTexture(easyDestro.textureList[easyDestro.spellList["current"]])
    end
    
    if easyDestro.spellList["next"] == secondSpell then
      -- yay
    else
      easyDestro.spellList["next"] = secondSpell
      easyDestro.textureList["next"]:SetTexture(easyDestro.textureList[easyDestro.spellList["next"]])
    end
    
    easyDestro.spellList["third"] = thirdSpell
    
    if firstSpell == "Inc" and secondSpell == "Inc" then
      easyDestro.textureList["next"]:SetTexture(easyDestro.textureList[easyDestro.spellList["third"]])
      easyDestro.spellList["next"] = easyDestro.spellList["third"]
      easyDestro.spellList["third"] = ""
    end
    
    if firstSpell == "CB" then
      easyDestro.cooldownFrame:SetCooldown(easyDestro.cboltTime, easyDestro.cboltCooldown)
    elseif firstSpell == "CFG" then
      easyDestro.cooldownFrame:SetCooldown(easyDestro.confTime, 10)
    end

  
end

function easyDestro:CheckStuff()
  local cboltCooldown = 12 --TODO add check for glyphs
  easyDestro.cboltCooldown = cboltCooldown
  easyDestro.codCD = 60
end



-- Options Panel


function easyDestro:GetLocked() 
  return easydestrodb.locked
end
function easyDestro:ToggleLocked()
  if easydestrodb.locked then
    easydestrodb.locked = false
    easyDestro.displayFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
    easyDestro.displayFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
    easyDestro.displayFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
    easyDestro.displayFrame:SetBackdropColor(0, 0, 0, .4)
	easyDestro.displayFrame:EnableMouse(true)
  else
    easydestrodb.locked = true
    easyDestro.displayFrame:SetScript("OnMouseDown", nil)
    easyDestro.displayFrame:SetScript("OnMouseUp", nil)
    easyDestro.displayFrame:SetScript("OnDragStop", nil)
    easyDestro.displayFrame:SetBackdropColor(0, 0, 0, 0)
    easyDestro.displayFrame:EnableMouse(false)
  end
end

function easyDestro:GetScale()
  return easydestrodb.scale
end
function easyDestro:SetScale(num)
  easydestrodb.scale = num
  easyDestro.displayFrame:SetScale(easydestrodb.scale)
  easyDestro.cooldownFrame:SetScale(easydestrodb.scale)
end


function easyDestro:CreateOptionFrame()
  local panel = CreateFrame("FRAME", "easyDestroOptions");
  panel.name = "easy Destro";
  local fstring1 = panel:CreateFontString("easyDestroOptions_string1","OVERLAY","GameFontNormal")
  local fstring5 = panel:CreateFontString("easyDestroOptions_string4","OVERLAY","GameFontNormal")
  fstring5:SetText("GUI Scale")
  fstring5:SetPoint("TOPLEFT", 10, -10)
  
  local slider2 = CreateFrame("Slider", "$parent_sl2", panel, "OptionsSliderTemplate")
  
  slider2:SetMinMaxValues(.5, 1.5)
  
  slider2:SetValue(easyDestro:GetScale())
  
  slider2:SetValueStep(.05)
  
  slider2:SetScript("OnValueChanged", function(self) easyDestro:SetScale(self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue())  end)

  getglobal(slider2:GetName() .. "Low"):SetText("0.5")
  getglobal(slider2:GetName() .. "High"):SetText("1.5")
  getglobal(slider2:GetName() .. "Text"):SetText(easyDestro:GetScale())
  
  slider2:SetPoint("TOPRIGHT", -10, -10)
  
  InterfaceOptions_AddCategory(panel); 
end

-- Slash Command
function easyDestro.Options()
  InterfaceOptionsFrame_OpenToCategory(getglobal("easyDestroOptions"))
end